#ifndef __G528API_H__
#define __G528API_H__

#ifdef WIN32_LEAN_AND_MEAN

#include <basetyps.h>

#endif

#include <windows.h>

#define G528_CLASS_ID_DEVICE_ENUMERATOR						0x1001
#define G528_CLASS_ID_DEVICE											0x1002
#define G528_CLASS_ID_COH_DEVICE_SET_ENUMERATOR   0x1003
#define G528_CLASS_ID_COH_DEVICE_SET              0x1004

#ifndef __G528_CREATE_INSTANCE__
#define __G528_CREATE_INSTANCE__

typedef BOOL (__stdcall *G528API_CREATE_INSTANCE)(UINT32 ClassId, PVOID *Interface);

#endif __G528_CREATE_INSTANCE__

#define G528_INTERFACE_TYPE_USB2		0
#define G528_INTERFACE_TYPE_USB3    1

#define G528_OPEN_DEMO		((CHAR*)0x00000000)
#define G528_OPEN_FIRST		((CHAR*)0xFFFFFFFF)

#define G528_AUDIO_SAMPLE_RATE     48000

#define G528_FREQUENCY_RANGE_SPLIT   50 * 1000 * 1000
#define G528_FREQUENCY_RANGE_MAX     100 * 1000 * 1000

#define G528_MODE_CW               0
#define G528_MODE_AM               1
#define G528_MODE_FM               2
#define G528_MODE_LSB              4
#define G528_MODE_USB              5
#define G528_MODE_AMS              8
#define G528_MODE_DRM              18
#define G528_MODE_DSB              13
#define G528_MODE_ISB              14

#define G528_MODE_COUNT            9

#define G528_SIDE_BAND_LOWER         0x01
#define G528_SIDE_BAND_UPPER         0x02
#define G528_SIDE_BAND_BOTH          (G528_SIDE_BAND_LOWER|G528_SIDE_BAND_UPPER)

#define G528_DEMODULATOR_PARAM_AMS_SIDE_BAND          0x00000001
#define G528_DEMODULATOR_PARAM_AMS_CAPTURE_RANGE      0x00000002
#define G528_DEMODULATOR_PARAM_CW_FREQUENCY           0x00000003
#define G528_DEMODULATOR_PARAM_DRM_AUDIO_SERVICE      0x00000004
#define G528_DEMODULATOR_PARAM_DRM_MULTIMEDIA_SERVICE 0x00000005
#define G528_DEMODULATOR_PARAM_DSB_SIDE_BAND          0x00000006
#define G528_DEMODULATOR_PARAM_ISB_SIDE_BAND          0x00000007

#define G528_DEMODULATOR_STATE_AMS_LOCK               0x00000001
#define G528_DEMODULATOR_STATE_AMS_FREQUENCY          0x00000002
#define G528_DEMODULATOR_STATE_AM_DEPTH               0x00000003
#define G528_DEMODULATOR_STATE_TUNE_ERROR             0x00000004
#define G528_DEMODULATOR_STATE_DRM_STATUS             0x00000005
#define G528_DEMODULATOR_STATE_FM_DEVIATION           0x00000006
#define G528_DEMODULATOR_STATE_DSB_LOCK               0x00000007
#define G528_DEMODULATOR_STATE_DSB_FREQUENCY          0x00000008

#define G528_FRONT_PANEL_LED_MODE_DIAG			0
#define G528_FRONT_PANEL_LED_MODE_ON			1
#define G528_FRONT_PANEL_LED_MODE_OFF			2

#define G528_DRM_STATE_MODE_NOT_DETERMINED_YET       -1
#define G528_DRM_STATE_MODE_A                        0
#define G528_DRM_STATE_MODE_B                        1
#define G528_DRM_STATE_MODE_C                        2
#define G528_DRM_STATE_MODE_D                        3

#define G528_DRM_STATE_INTERLEAVER_LONG              0       //long interleaver used (2 sec)
#define G528_DRM_STATE_INTERLEAVER_SHORT             1       //short interleaver used (400 msec)

#define G528_DRM_STATE_QAM_TYPE_STD                  0       //standard
#define G528_DRM_STATE_QAM_TYPE_HIER_SYM             1       //hierarchical symmetrical
#define G528_DRM_STATE_QAM_TYPE_HIER_MIX             2       //hierarchical mixed

#define G528_DRM_STATE_SERVICE_CONTENT_EMPTY         0x00    //service is not used/contains no data
#define G528_DRM_STATE_SERVICE_CONTENT_AUDIO         0x01    //service contains audio data
#define G528_DRM_STATE_SERVICE_CONTENT_TEXTMSG       0x02    //service contains text messages
#define G528_DRM_STATE_SERVICE_CONTENT_MULTIMEDIA    0x04    //service contains multimedia data
#define G528_DRM_STATE_SERVICE_CONTENT_DATA          0x08    //service contains application specific data

#define G528_DRM_STATE_AUDIO_CODING_AAC              0       //audio coding is AAC
#define G528_DRM_STATE_AUDIO_CODING_CELP             1       //audio coding is CELP
#define G528_DRM_STATE_AUDIO_CODING_HVXC             2       //audio coding is HVXC
#define G528_DRM_STATE_AUDIO_CODING_RFU              3       //reserved for future use

#define G528_DRM_STATE_AUDIO_MODE_AAC_MONO           0       //mono
#define G528_DRM_STATE_AUDIO_MODE_AAC_PARAM_STEREO   1       //parametric stereo
#define G528_DRM_STATE_AUDIO_MODE_AAC_STEREO         2       //stereo
#define G528_DRM_STATE_AUDIO_MODE_AAC_RFU            3       //reserved for future use
	
#define G528_DRM_STATE_AUDIO_MODE_CELP_NO_CRC        0       //audio data is without CRC
#define G528_DRM_STATE_AUDIO_MODE_CELP_CRC           1       //CRC used
#define G528_DRM_STATE_AUDIO_MODE_CELP_RFU_10        2       //reserved for future use
#define G528_DRM_STATE_AUDIO_MODE_CELP_RFU_11        3       //reserved for future use
	
#define G528_DRM_STATE_AUDIO_MODE_HVXC_RFU_00        0       //reserved for future use
#define G528_DRM_STATE_AUDIO_MODE_HVXC_RFU_01        1       //reserved for future use
#define G528_DRM_STATE_AUDIO_MODE_HVXC_RFU_10        2       //reserved for future use
#define G528_DRM_STATE_AUDIO_MODE_HVXC_RFU_11        3       //reserved for future use

#define G528_COM_PORT_BAUDRATE_600			600
#define G528_COM_PORT_BAUDRATE_1200			1200 
#define G528_COM_PORT_BAUDRATE_2400			2400 
#define G528_COM_PORT_BAUDRATE_4800			4800 
#define G528_COM_PORT_BAUDRATE_9600			9600 
#define G528_COM_PORT_BAUDRATE_14400		14400 
#define G528_COM_PORT_BAUDRATE_19200		19200 
#define G528_COM_PORT_BAUDRATE_28800		28800 
#define G528_COM_PORT_BAUDRATE_38400		38400 
#define G528_COM_PORT_BAUDRATE_56000		56000 
#define G528_COM_PORT_BAUDRATE_57600		57600
#define G528_COM_PORT_BAUDRATE_115200		115200

#pragma pack(push, 1)

typedef struct
{
    UINT32  Tune;   //Hz
    UINT32  Lock;   //Hz
} G528_AMS_CAPTURE_RANGE;

typedef struct
{
	BOOL            Valid;                          //entries below are invalid/valid

	struct
	{
		BOOL        SyncFound;
		BOOL        FACDecoded;
		BOOL        SDCDecoded;
		BOOL        AudioDecoded;
		SHORT       NumberOfAudioFrames;            //-1 if not available
		SHORT       NumberOfAudioErrors;            //-1 if not available	
	} DecodingState;


	INT32           Mode;                           //G528_DRM_STATE_MODE_*
	double          RFBandwidth;                    //occupied RF bandwith in kHz, 0 = invalid or information not (yet) available
	BYTE            Interleaver;                    //G528_DRM_STATE_INTERLEAVER_*
	SHORT           SDCQam;                         //coding of the SDC (QAM), 0 = not (yet) available
	SHORT           MSCQam;                         //coding of the MSC (QAM), 0 = not (yet) available
	BYTE            MSCQamType;                     //G528_DRM_STATE_QAM_TYPE_* , used QAM coding for the MSC
	double          CoderateH;				        //used coderate for hierachical coding,  values <= 0 indicate not available or not used
	double          CoderateA;				        //used coderate for protection level A,  values <= 0 indicate not available or not used
	double          CoderateB;				        //used coderate for protection level B,  values <= 0 indicate not available or not used
	double          EstimatedSNR;			        //estimated SNR in dB of the decoded signal
	WCHAR           TextMessage[128 + 1 + 16];      //text message containing max. 128 byte text + string termination + max. 16 linebreaks
   
	struct
	{
		BYTE        Content;				        //G528_DRM_STATE_SERVICE_CONTENT_*
		WCHAR       DynamicLabel[256];		        //string containing dynamic label of the service, zero terminated
		WCHAR       Country[256];			        //string containing the signaled country for this service
		WCHAR       Language[256];			        //string containing the signaled language for this service
		WCHAR       ProgramType[256];		        //string containing the signaled program type for this service
		double      AudioBitrate;			        //data rate for the audio content (0 if not available)
		double      TextMsgBitrate;			        //data rate for the text message content (0 if not available)
		double      MultimediaBitrate;		        //data rate for the multimedia content (0 if not available)
		double      DataBitrate;			        //data rate for the data content (0 if not available)
	} ServiceInfo[4];

	struct
	{
		BOOL        Valid;                          //audio decoder information valid/invalid, when invalid all other entries of the struct contain no valid data
		BYTE        AudioCoding;                    //G528_DRM_STATE_AUDIO_CODING_*        
		BOOL        SBR;                            //SBR used/not used (TRUE/FALSE)
		INT32       AudioMode;                      //depeding on the audio coding, G528_DRM_STATE_AUDIO_MODE_*
	} AudioDecoderInfo[4];
} G528_DRM_STATUS;

typedef struct
{
	char DevicePath[MAX_PATH];
	BYTE InterfaceType;
	char SerialNumber[9];
	WORD HWVersion;
	WORD FWVersion;
	BYTE EEPROMVersion;
	UINT32 ChannelCount;
	UINT32 DDCTypeCount;
} G528_DEVICE_INFO;

#define G528_OPEN_DEMO_SET			((G528_DEVICE_INFO*)0x00000000)
#define G528_OPEN_FIRST_SET			((G528_DEVICE_INFO*)0xFFFFFFFF)

#ifndef __G528_DDC_INFO__
#define __G528_DDC_INFO__

typedef struct
{
	UINT32 SampleRate;
	UINT32 Bandwidth;
	UINT32 BitsPerSample;
} G528_DDC_INFO;

#endif		//__G528_DDC_INFO__


#undef INTERFACE
#define INTERFACE IG528DeviceEnumerator

DECLARE_INTERFACE(IG528DeviceEnumerator)
{
	STDMETHOD_(LONG, AddRef)(THIS) PURE;
	STDMETHOD_(LONG, Release)(THIS) PURE;

	STDMETHOD_(BOOL, Enumerate)(THIS) PURE;
	STDMETHOD_(UINT32, GetCount)(THIS) PURE;
	STDMETHOD_(BOOL, GetDeviceInfo)(THIS_ UINT32 DeviceIndex, G528_DEVICE_INFO *DeviceInfo, UINT32 BufferLength) PURE;
};

#undef INTERFACE
#define INTERFACE IG528DeviceCallback

struct IG528Device;

DECLARE_INTERFACE(IG528DeviceCallback)
{
    STDMETHOD_(VOID,G528_DDC1StreamCallback)(THIS_ struct IG528Device *Device, CONST VOID *Buffer, UINT32 NumberOfSamples, UINT32 BitsPerSample) PURE;
    STDMETHOD_(BOOL,G528_DDC1PlaybackStreamCallback)(THIS_ struct IG528Device *Device,VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample) PURE;
    STDMETHOD_(VOID,G528_DDC2StreamCallback)(THIS_ struct IG528Device *Device, CONST FLOAT *Buffer,UINT32 NumberOfSamples) PURE;        
    //SlevelPeak and SlevelRMS are in Volts
    //to convert SlevelRMS to power in dBm use SlevelRMS_dBm=10.0*log10(SlevelRMS*SlevelRMS/50.0*1000.0); where 50.0 is receiver input impendance, 1000.0 is coefficents to convert Watts to milli Watts
    STDMETHOD_(VOID,G528_DDC2PreprocessedStreamCallback)(THIS_ struct IG528Device *Device,CONST FLOAT *Buffer,UINT32 NumberOfSamples,FLOAT SlevelPeak,FLOAT SlevelRMS) PURE;        
    STDMETHOD_(VOID,G528_AudioStreamCallback)(THIS_ struct IG528Device *Device,UINT32 Type,CONST FLOAT *Buffer,UINT32 NumberOfSamples) PURE;
};

#undef INTERFACE
#define INTERFACE IG528Device

DECLARE_INTERFACE(IG528Device)
{
	STDMETHOD_(LONG, AddRef)(THIS) PURE;
	STDMETHOD_(LONG, Release)(THIS) PURE;

	STDMETHOD_(BOOL, Open)(THIS_ CONST CHAR *DevicePath) PURE;
	STDMETHOD_(VOID, Close)(THIS) PURE;
	STDMETHOD_(BOOL, IsOpen)(THIS) PURE;

	STDMETHOD_(BOOL, IsConnected)(THIS) PURE;

	STDMETHOD_(VOID, SetCallback)(THIS_ IG528DeviceCallback *Callback) PURE;
	STDMETHOD_(IG528DeviceCallback*, GetCallback)(THIS) PURE;

	STDMETHOD_(BOOL, GetDeviceInfo)(THIS_ G528_DEVICE_INFO *Info, UINT32 BufferLength) PURE;

	STDMETHOD_(BOOL, SetPower)(THIS_ BOOL Power) PURE;
	STDMETHOD_(BOOL, GetPower)(THIS_ BOOL *Power) PURE;

	STDMETHOD_(BOOL,SetInverted)(THIS_ BOOL Inverted) PURE;
	STDMETHOD_(BOOL,GetInverted)(THIS_ BOOL *Inverted) PURE;       

	STDMETHOD_(BOOL,GetDDCInfo)(THIS_ UINT32 DDCTypeIndex,G528_DDC_INFO *Info) PURE;
	STDMETHOD_(BOOL,GetDDC1Count)(THIS_ UINT32 *Count) PURE;
	STDMETHOD_(BOOL,SetDDC1)(THIS_ UINT32 DDCTypeIndex) PURE;
	STDMETHOD_(BOOL,GetDDC1)(THIS_ UINT32 *DDCTypeIndex, G528_DDC_INFO *DDCInfo) PURE;

	STDMETHOD_(BOOL,StartDDC1)(THIS_ UINT32 SamplesPerBuffer) PURE;
	STDMETHOD_(BOOL,StopDDC1)(THIS) PURE;
  
	STDMETHOD_(BOOL,StartDDC1Playback)(THIS_ UINT32 SamplesPerBuffer,UINT32 BitsPerSample) PURE; //BitsPerSample: 0 - default by DDC Info, 16 or 32
	STDMETHOD_(BOOL,PauseDDC1Playback)(THIS) PURE;
	STDMETHOD_(BOOL,ResumeDDC1Playback)(THIS) PURE;

	STDMETHOD_(BOOL,SetDDC1Frequency)(THIS_ UINT32 Frequency) PURE;
	STDMETHOD_(BOOL,GetDDC1Frequency)(THIS_ UINT32 *Frequency) PURE;

	STDMETHOD_(BOOL,GetDDC2)(THIS_ UINT32 *DDCTypeIndex,G528_DDC_INFO *DDCInfo) PURE;

	STDMETHOD_(BOOL,StartDDC2)(THIS_ UINT32 SamplesPerBuffer) PURE;
	STDMETHOD_(BOOL,StopDDC2)(THIS) PURE;

	STDMETHOD_(BOOL,SetDDC2Frequency)(THIS_ INT32 Frequency) PURE;
	STDMETHOD_(BOOL,GetDDC2Frequency)(THIS_ INT32 *Frequency) PURE;

	STDMETHOD_(BOOL,SetDDC2NoiseBlanker)(THIS_ BOOL Enabled) PURE;
	STDMETHOD_(BOOL,GetDDC2NoiseBlanker)(THIS_ BOOL *Enabled) PURE;
	STDMETHOD_(BOOL,SetDDC2NoiseBlankerThreshold)(THIS_ double Threshold) PURE;
	STDMETHOD_(BOOL,GetDDC2NoiseBlankerThreshold)(THIS_ double *Threshold) PURE;
	STDMETHOD_(BOOL,GetDDC2NoiseBlankerExcessValue)(THIS_ double *Value) PURE;

	STDMETHOD_(BOOL,GetSignalLevel)(THIS_ FLOAT *Peak,FLOAT *RMS) PURE;

	STDMETHOD_(BOOL,SetAGC)(THIS_ BOOL Enabled) PURE;
	STDMETHOD_(BOOL,GetAGC)(THIS_ BOOL *Enabled) PURE;
	STDMETHOD_(BOOL,SetAGCParams)(THIS_ double AttackTime,double DecayTime,double ReferenceLevel) PURE;
	STDMETHOD_(BOOL,GetAGCParams)(THIS_ double *AttackTime,double *DecayTime,double *ReferenceLevel) PURE;
	STDMETHOD_(BOOL,SetMaxAGCGain)(THIS_ double MaxGain) PURE;
	STDMETHOD_(BOOL,GetMaxAGCGain)(THIS_ double *MaxGain) PURE;
	STDMETHOD_(BOOL,SetGain)(THIS_ double Gain) PURE;
	STDMETHOD_(BOOL,GetGain)(THIS_ double *Gain) PURE;
	STDMETHOD_(BOOL,GetCurrentGain)(THIS_ double *Gain) PURE;

	STDMETHOD_(BOOL,SetNotchFilter)(THIS_ UINT32 NotchFilterIndex,BOOL Enabled) PURE;
	STDMETHOD_(BOOL,GetNotchFilter)(THIS_ UINT32 NotchFilterIndex,BOOL *Enabled) PURE;
	STDMETHOD_(BOOL,SetNotchFilterFrequency)(THIS_ UINT32 NotchFilterIndex,INT32 Frequency) PURE;
	STDMETHOD_(BOOL,GetNotchFilterFrequency)(THIS_ UINT32 NotchFilterIndex,INT32 *Frequency) PURE;
	STDMETHOD_(BOOL,SetNotchFilterBandwidth)(THIS_ UINT32 NotchFilterIndex,UINT32 Bandwidth) PURE;
	STDMETHOD_(BOOL,GetNotchFilterBandwidth)(THIS_ UINT32 NotchFilterIndex,UINT32 *Bandwidth) PURE;
	STDMETHOD_(BOOL,SetNotchFilterLength)(THIS_ UINT32 NotchFilterIndex,UINT32 Length) PURE;         //Length: min=64,max=32768,step=64
	STDMETHOD_(BOOL,GetNotchFilterLength)(THIS_ UINT32 NotchFilterIndex,UINT32 *Length) PURE;

	STDMETHOD_(BOOL,SetDemodulatorMode)(THIS_ UINT32 Mode) PURE;
	STDMETHOD_(BOOL,GetDemodulatorMode)(THIS_ UINT32 *Mode) PURE;
	STDMETHOD_(BOOL,SetDemodulatorFrequency)(THIS_ INT32 Frequency) PURE;
	STDMETHOD_(BOOL,GetDemodulatorFrequency)(THIS_ INT32 *Frequency) PURE;
	STDMETHOD_(BOOL,SetDemodulatorFilterBandwidth)(THIS_ UINT32 Bandwidth) PURE;
	STDMETHOD_(BOOL,GetDemodulatorFilterBandwidth)(THIS_ UINT32 *Bandwidth) PURE;
	STDMETHOD_(BOOL,SetDemodulatorFilterShift)(THIS_ INT32 Shift) PURE;
	STDMETHOD_(BOOL,GetDemodulatorFilterShift)(THIS_ INT32 *Shift) PURE;
	STDMETHOD_(BOOL,SetDemodulatorFilterLength)(THIS_ UINT32 Length) PURE;   //Length: min=64,max=32768,step=64
	STDMETHOD_(BOOL,GetDemodulatorFilterLength)(THIS_ UINT32 *Length) PURE;

	STDMETHOD_(BOOL,SetDemodulatorParam)(THIS_ UINT32 Code,CONST VOID *Buffer,UINT32 BufferSize) PURE;
	STDMETHOD_(BOOL,GetDemodulatorParam)(THIS_ UINT32 Code,VOID *Buffer,UINT32 BufferSize) PURE;
	STDMETHOD_(BOOL,GetDemodulatorState)(THIS_ UINT32 Code,VOID *Buffer,UINT32 BufferSize) PURE;  

	STDMETHOD_(BOOL,StartAudio)(THIS_ UINT32 SamplesPerBuffer) PURE;
	STDMETHOD_(BOOL,StopAudio)(THIS) PURE;

	STDMETHOD_(BOOL,SetAudioFilter)(THIS_ BOOL Enabled) PURE;
	STDMETHOD_(BOOL,GetAudioFilter)(THIS_ BOOL *Enabled) PURE;
	STDMETHOD_(BOOL,SetAudioFilterParams)(THIS_ UINT32 CutOffLow,UINT32 CutOffHigh,double Deemphasis) PURE;    
	STDMETHOD_(BOOL,GetAudioFilterParams)(THIS_ UINT32 *CutOffLow,UINT32 *CutOffHigh,double *Deemphasis) PURE;    
	STDMETHOD_(BOOL,SetAudioFilterLength)(THIS_ UINT32 Length) PURE;         //Length: min=64,max=32768,step64
	STDMETHOD_(BOOL,GetAudioFilterLength)(THIS_ UINT32 *Length) PURE;
	STDMETHOD_(BOOL,SetAudioGain)(THIS_ double Gain) PURE;
	STDMETHOD_(BOOL,GetAudioGain)(THIS_ double *Gain) PURE;  
	STDMETHOD_(BOOL,SetVolume)(THIS_ BYTE Volume) PURE;
	STDMETHOD_(BOOL,GetVolume)(THIS_ BYTE *Volume) PURE;    
	STDMETHOD_(BOOL,SetMute)(THIS_ BOOL Mute) PURE;
	STDMETHOD_(BOOL,GetMute)(THIS_ BOOL *Mute) PURE;

	STDMETHOD_(BOOL,SetDRMKey)(THIS_ CONST CHAR *DRMKeyFileDirectory) PURE;
	STDMETHOD_(BOOL,IsDRMUnlocked)(THIS) PURE;

	STDMETHOD_(BOOL,GetSpectrumCompensation)(THIS_ UINT32 CenterFrequency,UINT32 Width,FLOAT *Buffer,UINT32 Count) PURE;

	STDMETHOD_(BOOL,SetFrequency)(THIS_ UINT32 Frequency) PURE;
	STDMETHOD_(BOOL,GetFrequency)(THIS_ UINT32 *Frequency) PURE;

	STDMETHOD_(BOOL,InitADC)(THIS) PURE;
	STDMETHOD_(BOOL,DisableADCOscillator)(THIS) PURE;
	STDMETHOD_(BOOL,DisableADCFrequencyReference)(THIS) PURE;
	STDMETHOD_(BOOL,IsADCClockPresent)(THIS) PURE;
	STDMETHOD_(BOOL,IsADCSamplingClockLocked)(THIS) PURE;

	STDMETHOD_(BOOL,OpenCOMPort)(THIS_ UINT32 Baudrate) PURE;
	STDMETHOD_(BOOL,CloseCOMPort)(THIS) PURE;
	STDMETHOD_(BOOL,IsCOMPortOpened)(THIS) PURE;
	STDMETHOD_(BOOL,ReadFromCOMPort)(THIS_ VOID *Buffer, UINT32 BufferSize, UINT32 *ReadSize) PURE;
	STDMETHOD_(BOOL,WriteToCOMPort)(THIS_ VOID *Buffer, UINT32 BufferSize) PURE;
	STDMETHOD_(BOOL,SetCOMPortTimeout)(THIS_ UINT32 Timeout) PURE;

};

#undef INTERFACE
#define INTERFACE ICohG528DeviceSetEnumerator

DECLARE_INTERFACE(ICohG528DeviceSetEnumerator)
{
	STDMETHOD_(LONG, AddRef)(THIS) PURE;
	STDMETHOD_(LONG, Release)(THIS) PURE;

	STDMETHOD_(BOOL, Enumerate)(THIS) PURE;
	STDMETHOD_(UINT32, GetDeviceSetCount)(THIS) PURE;
	STDMETHOD_(BOOL, GetDeviceSetInfo)(THIS_ UINT32 SetIndex, G528_DEVICE_INFO *DeviceInfos, UINT32 *DeviceInfosCount) PURE;
};

#undef INTERFACE
#define INTERFACE ICohG528DeviceSetCallback

struct ICohG528DeviceSet;

DECLARE_INTERFACE(ICohG528DeviceSetCallback)
{
	STDMETHOD_(VOID, CohG528_DDC1StreamCallback)(THIS_ struct ICohG528DeviceSet *DeviceSet, UINT32 DeviceCount, CONST VOID **Buffer, UINT32 NumberOfSamples, UINT32 BitsPerSample) PURE;
	STDMETHOD_(VOID, CohG528_DDC2StreamCallback)(THIS_ struct ICohG528DeviceSet *DeviceSet, UINT32 DeviceIndex, CONST FLOAT *Buffer, UINT32 NumberOfSamples) PURE;
	//SlevelPeak and SlevelRMS are in Volts
	//to convert SlevelRMS to power in dBm use SlevelRMS_dBm=10.0*log10(SlevelRMS*SlevelRMS/50.0*1000.0); where 50.0 is receiver input impendance, 1000.0 is coefficents to convert Watts to milli Watts
	STDMETHOD_(VOID, CohG528_DDC2PreprocessedStreamCallback)(THIS_ struct ICohG528DeviceSet *DeviceSet, UINT32 DeviceIndex, CONST FLOAT *Buffer, UINT32 NumberOfSamples, FLOAT SlevelPeak, FLOAT SlevelRMS) PURE;
	STDMETHOD_(VOID, CohG528_AudioStreamCallback)(THIS_ struct ICohG528DeviceSet *DeviceSet, UINT32 DeviceIndex, UINT32 Type, CONST FLOAT *Buffer, UINT32 NumberOfSamples) PURE;
};

#undef INTERFACE
#define INTERFACE ICohG528DeviceSet

DECLARE_INTERFACE(ICohG528DeviceSet)
{
	STDMETHOD_(LONG, AddRef)(THIS) PURE;
	STDMETHOD_(LONG, Release)(THIS) PURE;

	STDMETHOD_(BOOL, Open)(THIS_ G528_DEVICE_INFO *DeviceInfos, UINT32 Count) PURE;
	STDMETHOD_(VOID, Close)(THIS) PURE;
	STDMETHOD_(BOOL, IsOpen)(THIS) PURE;

	STDMETHOD_(BOOL, GetDeviceCount)(THIS_ UINT32 *Count) PURE;

	STDMETHOD_(BOOL, IsConnected)(THIS) PURE;

	STDMETHOD_(VOID, SetCallback)(THIS_ ICohG528DeviceSetCallback *Callback) PURE;
	STDMETHOD_(ICohG528DeviceSetCallback*, GetCallback)(THIS) PURE;

	STDMETHOD_(BOOL, GetDeviceInfo)(THIS_ UINT32 DeviceIndex, G528_DEVICE_INFO *Info) PURE;
	STDMETHOD_(BOOL, GetDeviceInfos)(THIS_ G528_DEVICE_INFO *Infos, UINT32 *InfoCount) PURE;

	STDMETHOD_(BOOL, SetPower)(THIS_ BOOL Power) PURE;
	STDMETHOD_(BOOL, GetPower)(THIS_ BOOL *Power) PURE;

	STDMETHOD_(BOOL, SetInverted)(THIS_ BOOL Inverted) PURE;
	STDMETHOD_(BOOL, GetInverted)(THIS_ BOOL *Inverted) PURE;

	STDMETHOD_(BOOL, GetDDCInfo)(THIS_ UINT32 DDCTypeIndex, G528_DDC_INFO *Info) PURE;
	STDMETHOD_(BOOL, GetDDC1Count)(THIS_ UINT32 *Count) PURE;
	STDMETHOD_(BOOL, SetDDC1)(THIS_ UINT32 DDCTypeIndex) PURE;
	STDMETHOD_(BOOL, GetDDC1)(THIS_ UINT32 *DDCTypeIndex, G528_DDC_INFO *DDCInfo) PURE;
	STDMETHOD_(BOOL, StartDDC1)(THIS_ UINT32 SamplesPerBuffer) PURE;
	STDMETHOD_(BOOL, StopDDC1)(THIS) PURE;  
	STDMETHOD_(BOOL, SetDDC1Frequency)(THIS_ UINT32 Frequency) PURE;
	STDMETHOD_(BOOL, GetDDC1Frequency)(THIS_ UINT32 *Frequency) PURE;
	STDMETHOD_(BOOL, SetDDC1PhaseShift)(THIS_ UINT32 DeviceIndex, double PhaseShift) PURE;
	STDMETHOD_(BOOL, GetDDC1PhaseShift)(THIS_ UINT32 DeviceIndex, double *PhaseShift) PURE;

	STDMETHOD_(BOOL, GetDDC2)(THIS_ UINT32 *DDCTypeIndex, G528_DDC_INFO *DDCInfo) PURE;
	STDMETHOD_(BOOL, StartDDC2)(THIS_ UINT32 DeviceIndex, UINT32 SamplesPerBuffer) PURE;
	STDMETHOD_(BOOL, StopDDC2)(THIS_ UINT32 DeviceIndex) PURE;
	STDMETHOD_(BOOL, SetDDC2Frequency)(THIS_ UINT32 DeviceIndex, INT32 Frequency) PURE;
	STDMETHOD_(BOOL, GetDDC2Frequency)(THIS_ UINT32 DeviceIndex, INT32 *Frequency) PURE;
	STDMETHOD_(BOOL, SetDDC2NoiseBlanker)(THIS_ UINT32 DeviceIndex, BOOL Enabled) PURE;
	STDMETHOD_(BOOL, GetDDC2NoiseBlanker)(THIS_ UINT32 DeviceIndex, BOOL *Enabled) PURE;
	STDMETHOD_(BOOL, SetDDC2NoiseBlankerThreshold)(THIS_ UINT32 DeviceIndex, double Threshold) PURE;
	STDMETHOD_(BOOL, GetDDC2NoiseBlankerThreshold)(THIS_ UINT32 DeviceIndex, double *Threshold) PURE;
	STDMETHOD_(BOOL, GetDDC2NoiseBlankerExcessValue)(THIS_ UINT32 DeviceIndex, double *Value) PURE;

	STDMETHOD_(BOOL, GetSignalLevel)(THIS_ UINT32 DeviceIndex, FLOAT *Peak, FLOAT *RMS) PURE;

	STDMETHOD_(BOOL, SetAGC)(THIS_ UINT32 DeviceIndex, BOOL Enabled) PURE;
	STDMETHOD_(BOOL, GetAGC)(THIS_ UINT32 DeviceIndex,BOOL *Enabled) PURE;
	STDMETHOD_(BOOL, SetAGCParams)(THIS_ UINT32 DeviceIndex, double AttackTime, double DecayTime, double ReferenceLevel) PURE;
	STDMETHOD_(BOOL, GetAGCParams)(THIS_ UINT32 DeviceIndex, double *AttackTime, double *DecayTime, double *ReferenceLevel) PURE;
	STDMETHOD_(BOOL, SetMaxAGCGain)(THIS_ UINT32 DeviceIndex, double MaxGain) PURE;
	STDMETHOD_(BOOL, GetMaxAGCGain)(THIS_ UINT32 DeviceIndex, double *MaxGain) PURE;
	STDMETHOD_(BOOL, SetGain)(THIS_ UINT32 DeviceIndex, double Gain) PURE;
	STDMETHOD_(BOOL, GetGain)(THIS_ UINT32 DeviceIndex, double *Gain) PURE;
	STDMETHOD_(BOOL,GetCurrentGain)(THIS_ UINT32 DeviceIndex,double *Gain) PURE;

	STDMETHOD_(BOOL, SetNotchFilter)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, BOOL Enabled) PURE;
	STDMETHOD_(BOOL, GetNotchFilter)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, BOOL *Enabled) PURE;
	STDMETHOD_(BOOL, SetNotchFilterFrequency)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, INT32 Frequency) PURE;
	STDMETHOD_(BOOL, GetNotchFilterFrequency)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, INT32 *Frequency) PURE;
	STDMETHOD_(BOOL, SetNotchFilterBandwidth)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 Bandwidth) PURE;
	STDMETHOD_(BOOL, GetNotchFilterBandwidth)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 *Bandwidth) PURE;
	STDMETHOD_(BOOL, SetNotchFilterLength)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 Length) PURE;         //Length: min=64,max=32768,step=64
	STDMETHOD_(BOOL, GetNotchFilterLength)(THIS_ UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 *Length) PURE;

	STDMETHOD_(BOOL, SetDemodulatorMode)(THIS_ UINT32 DeviceIndex, UINT32 Mode) PURE;
	STDMETHOD_(BOOL, GetDemodulatorMode)(THIS_ UINT32 DeviceIndex, UINT32 *Mode) PURE;
	STDMETHOD_(BOOL, SetDemodulatorFrequency)(THIS_ UINT32 DeviceIndex, INT32 Frequency) PURE;
	STDMETHOD_(BOOL, GetDemodulatorFrequency)(THIS_ UINT32 DeviceIndex, INT32 *Frequency) PURE;
	STDMETHOD_(BOOL, SetDemodulatorFilterBandwidth)(THIS_ UINT32 DeviceIndex, UINT32 Bandwidth) PURE;
	STDMETHOD_(BOOL, GetDemodulatorFilterBandwidth)(THIS_ UINT32 DeviceIndex, UINT32 *Bandwidth) PURE;
	STDMETHOD_(BOOL, SetDemodulatorFilterShift)(THIS_ UINT32 DeviceIndex, INT32 Shift) PURE;
	STDMETHOD_(BOOL, GetDemodulatorFilterShift)(THIS_ UINT32 DeviceIndex, INT32 *Shift) PURE;
	STDMETHOD_(BOOL, SetDemodulatorFilterLength)(THIS_ UINT32 DeviceIndex, UINT32 Length) PURE;   //Length: min=64,max=32768,step=64
	STDMETHOD_(BOOL, GetDemodulatorFilterLength)(THIS_ UINT32 DeviceIndex, UINT32 *Length) PURE;

	STDMETHOD_(BOOL, SetDemodulatorParam)(THIS_ UINT32 DeviceIndex, UINT32 Code, CONST VOID *Buffer, UINT32 BufferSize) PURE;
	STDMETHOD_(BOOL, GetDemodulatorParam)(THIS_ UINT32 DeviceIndex, UINT32 Code, VOID *Buffer, UINT32 BufferSize) PURE;
	STDMETHOD_(BOOL, GetDemodulatorState)(THIS_ UINT32 DeviceIndex, UINT32 Code, VOID *Buffer, UINT32 BufferSize) PURE;

	STDMETHOD_(BOOL, StartAudio)(THIS_ UINT32 DeviceIndex,UINT32 SamplesPerBuffer) PURE;
	STDMETHOD_(BOOL, StopAudio)(THIS_ UINT32 DeviceIndex) PURE;
       
	STDMETHOD_(BOOL, SetAudioFilter)(THIS_ UINT32 DeviceIndex, BOOL Enabled) PURE;
	STDMETHOD_(BOOL, GetAudioFilter)(THIS_ UINT32 DeviceIndex, BOOL *Enabled) PURE;
	STDMETHOD_(BOOL, SetAudioFilterParams)(THIS_ UINT32 DeviceIndex, UINT32 CutOffLow, UINT32 CutOffHigh, double Deemphasis) PURE;
	STDMETHOD_(BOOL, GetAudioFilterParams)(THIS_ UINT32 DeviceIndex, UINT32 *CutOffLow, UINT32 *CutOffHigh, double *Deemphasis) PURE;
	STDMETHOD_(BOOL, SetAudioFilterLength)(THIS_ UINT32 DeviceIndex, UINT32 Length) PURE;         //Length: min=64,max=32768,step64
	STDMETHOD_(BOOL, GetAudioFilterLength)(THIS_ UINT32 DeviceIndex, UINT32 *Length) PURE;
	STDMETHOD_(BOOL, SetAudioGain)(THIS_ UINT32 DeviceIndex, double Gain) PURE;
	STDMETHOD_(BOOL, GetAudioGain)(THIS_ UINT32 DeviceIndex, double *Gain) PURE;  
	STDMETHOD_(BOOL, SetVolume)(THIS_ UINT32 DeviceIndex, BYTE Volume) PURE;
	STDMETHOD_(BOOL, GetVolume)(THIS_ UINT32 DeviceIndex, BYTE *Volume) PURE;    
	STDMETHOD_(BOOL, SetMute)(THIS_ UINT32 DeviceIndex, BOOL Mute) PURE;
	STDMETHOD_(BOOL, GetMute)(THIS_ UINT32 DeviceIndex, BOOL *Mute) PURE;

	STDMETHOD_(BOOL, SetDRMKey)(THIS_ CONST CHAR *DRMKeyFileDirectory) PURE;
	STDMETHOD_(BOOL, IsDRMUnlocked)(THIS) PURE;

	STDMETHOD_(BOOL, GetSpectrumCompensation)(THIS_ UINT32 DeviceIndex,UINT32 CenterFrequency,UINT32 Width,FLOAT *Buffer,UINT32 Count) PURE;    

	STDMETHOD_(BOOL, InitADC)(THIS_ UINT32 DeviceIndex) PURE;
	STDMETHOD_(BOOL, DisableADCOscillator)(THIS_ UINT32 DeviceIndex) PURE;
	STDMETHOD_(BOOL, DisableADCFrequencyReference)(THIS_ UINT32 DeviceIndex) PURE;
	STDMETHOD_(BOOL, IsADCClockPresent)(THIS_ UINT32 DeviceIndex) PURE;
	STDMETHOD_(BOOL, IsADCSamplingClockLocked)(THIS_ UINT32 DeviceIndex) PURE;

	STDMETHOD_(BOOL, OpenCOMPort)(THIS_ UINT32 DeviceIndex, UINT32 Baudrate) PURE;
	STDMETHOD_(BOOL, CloseCOMPort)(THIS_ UINT32 DeviceIndex) PURE;
	STDMETHOD_(BOOL, IsCOMPortOpened)(THIS_ UINT32 DeviceIndex) PURE;
	STDMETHOD_(BOOL, ReadFromCOMPort)(THIS_ UINT32 DeviceIndex, VOID *Buffer, UINT32 BufferSize, UINT32 *ReadSize) PURE;
	STDMETHOD_(BOOL, WriteToCOMPort)(THIS_ UINT32 DeviceIndex, VOID *Buffer, UINT32 BufferSize) PURE;
	STDMETHOD_(BOOL, SetCOMPortTimeout)(THIS_ UINT32 DeviceIndex, UINT32 Timeout) PURE;
};

typedef VOID (__stdcall *G528_IF_CALLBACK)(CONST SHORT *Buffer,UINT32 NumberOfSamples,WORD MaxADCAmplitude,UINT32 ADCSamplingRate,DWORD_PTR UserData);
typedef VOID (__stdcall *G528_DDC1_STREAM_CALLBACK)(CONST VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample,DWORD_PTR UserData);
typedef BOOL (__stdcall *G528_DDC1_PLAYBACK_STREAM_CALLBACK)(VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample,DWORD_PTR UserData);
typedef VOID (__stdcall *G528_DDC2_STREAM_CALLBACK)(CONST FLOAT *Buffer,UINT32 NumberOfSamples,DWORD_PTR UserData);
typedef VOID (__stdcall *G528_DDC2_PREPROCESSED_STREAM_CALLBACK)(CONST FLOAT *Buffer,UINT32 NumberOfSamples,FLOAT SlevelPeak,FLOAT SlevelRMS,DWORD_PTR UserData);
typedef VOID (__stdcall *G528_AUDIO_STREAM_CALLBACK)(UINT32 Type,CONST FLOAT *Buffer,UINT32 NumberOfSamples,DWORD_PTR UserData);

typedef struct
{
	G528_DDC1_STREAM_CALLBACK                 DDC1StreamCallback;
	G528_DDC1_PLAYBACK_STREAM_CALLBACK        DDC1PlaybackStreamCallback;
	G528_DDC2_STREAM_CALLBACK                 DDC2StreamCallback;
	G528_DDC2_PREPROCESSED_STREAM_CALLBACK    DDC2PreprocessedStreamCallback;
	G528_AUDIO_STREAM_CALLBACK                AudioStreamCallback;
} G528_CALLBACKS;

#pragma pack(pop)

//GetDeviceList
typedef INT32 (__stdcall *G528_GET_DEVICE_LIST)(G528_DEVICE_INFO *DeviceList, UINT32 BufferSize);
//OpenDevice
typedef INT32 (__stdcall *G528_OPEN_DEVICE)(const char *SerialNumber);
//CloseDevice
typedef BOOL (__stdcall *G528_CLOSE_DEVICE)(INT32 hDevice);
//IsDeviceConnected
typedef BOOL (__stdcall *G528_IS_DEVICE_CONNECTED)(INT32 hDevice);
//GetDeviceInfo
typedef BOOL (__stdcall *G528_GET_DEVICE_INFO)(INT32 hDevice, G528_DEVICE_INFO *Info, UINT32 BufferLength);
//SetPower
typedef BOOL (__stdcall *G528_SET_POWER)(INT32 hDevice, BOOL Power);
//GetPower
typedef BOOL (__stdcall *G528_GET_POWER)(INT32 hDevice, BOOL *Power);
//SetInverted    
typedef BOOL (__stdcall *G528_SET_INVERTED)(INT32 hDevice, BOOL Inverted);
//GetInverted    
typedef BOOL (__stdcall *G528_GET_INVERTED)(INT32 hDevice, BOOL *Inverted);
//GetDDCInfo
typedef BOOL (__stdcall *G528_GET_DDC_INFO)(INT32 hDevice, UINT32 DDCTypeIndex, G528_DDC_INFO *Info);
//GetDDC1Count
typedef BOOL (__stdcall *G528_GET_DDC1_COUNT)(INT32 hDevice, UINT32 *Count);
//SetDDC1
typedef BOOL (__stdcall *G528_SET_DDC1)(INT32 hDevice, UINT32 DDCTypeIndex);
//GetDDC1
typedef BOOL (__stdcall *G528_GET_DDC1)(INT32 hDevice, UINT32 *DDCTypeIndex, G528_DDC_INFO *DDCInfo);
//StartDDC1
typedef BOOL (__stdcall *G528_START_DDC1)(INT32 hDevice, UINT32 SamplesPerBuffer);
//StopDDC1
typedef BOOL (__stdcall *G528_STOP_DDC1)(INT32 hDevice);
//StartDDC1Playback
typedef BOOL (__stdcall *G528_START_DDC1_PLAYBACK)(INT32 hDevice, UINT32 SamplesPerBuffer, UINT32 BitsPerSample);
//PauseDDC1Playback
typedef BOOL (__stdcall *G528_PAUSE_DDC1_PLAYBACK)(INT32 hDevice);
//ResumeDDC1Playback
typedef BOOL (__stdcall *G528_RESUME_DDC1_PLAYBACK)(INT32 hDevice);
//SetDDC1Frequency
typedef BOOL (__stdcall *G528_SET_DDC1_FREQUENCY)(INT32 hDevice, UINT32 Frequency);
//GetDDC1Frequency
typedef BOOL (__stdcall *G528_GET_DDC1_FREQUENCY)(INT32 hDevice, UINT32 *Frequency);
//GetDDC2
typedef BOOL (__stdcall *G528_GET_DDC2)(INT32 hDevice, UINT32 *DDCTypeIndex, G528_DDC_INFO *DDCInfo);
//StartDDC2
typedef BOOL (__stdcall *G528_START_DDC2)(INT32 hDevice, UINT32 SamplesPerBuffer);
//StopDDC2
typedef BOOL (__stdcall *G528_STOP_DDC2)(INT32 hDevice);
//SetDDC2Frequency
typedef BOOL (__stdcall *G528_SET_DDC2_FREQUENCY)(INT32 hDevice, INT32 Frequency);
//GetDDC2Frequency
typedef BOOL (__stdcall *G528_GET_DDC2_FREQUENCY)(INT32 hDevice, INT32 *Frequency);
//SetDDC2NoiseBlanker
typedef BOOL (__stdcall *G528_SET_DDC2_NOISE_BLANKER)(INT32 hDevice, BOOL Enabled);
//GetDDC2NoiseBlanker
typedef BOOL (__stdcall *G528_GET_DDC2_NOISE_BLANKER)(INT32 hDevice, BOOL *Enabled);
//SetDDC2NoiseBlankerThreshold
typedef BOOL (__stdcall *G528_SET_DDC2_NOISE_BLANKER_THRESHOLD)(INT32 hDevice, double Threshold);
//GetDDC2NoiseBlankerThreshold
typedef BOOL (__stdcall *G528_GET_DDC2_NOISE_BLANKER_THRESHOLD)(INT32 hDevice, double *Threshold);
//GetDDC2NoiseBlankerExcessValue
typedef BOOL (__stdcall *G528_GET_DDC2_NOISE_BLANKER_EXCESS_VALUE)(INT32 hDevice, double *Value);
//GetSignalLevel
typedef BOOL (__stdcall *G528_GET_SIGNAL_LEVEL)(INT32 hDevice, FLOAT *Peak, FLOAT *RMS);
//SetAGC
typedef BOOL (__stdcall *G528_SET_AGC)(INT32 hDevice, BOOL Enabled);
//GetAGC
typedef BOOL (__stdcall *G528_GET_AGC)(INT32 hDevice, BOOL *Enabled);
//SetAGCParams
typedef BOOL (__stdcall *G528_SET_AGC_PARAMS)(INT32 hDevice, double AttackTime, double DecayTime, double ReferenceLevel);
//GetAGCParams
typedef BOOL (__stdcall *G528_GET_AGC_PARAMS)(INT32 hDevice, double *AttackTime, double *DecayTime, double *ReferenceLevel);
//SetMaxAGCGain
typedef BOOL (__stdcall *G528_SET_MAX_AGC_GAIN)(INT32 hDevice, double MaxGain);
//GetMaxAGCGain
typedef BOOL (__stdcall *G528_GET_MAX_AGC_GAIN)(INT32 hDevice, double *MaxGain);
//SetGain
typedef BOOL (__stdcall *G528_SET_GAIN)(INT32 hDevice, double Gain);
//GetGain
typedef BOOL (__stdcall *G528_GET_GAIN)(INT32 hDevice, double *Gain);
//GetCurrentGain
typedef BOOL (__stdcall *G528_GET_CURRENT_GAIN)(INT32 hDevice, double *Gain);
//SetNotchFilter
typedef BOOL (__stdcall *G528_SET_NOTCH_FILTER)(INT32 hDevice, UINT32 NotchFilterIndex, BOOL Enabled);
//GetNotchFilter
typedef BOOL (__stdcall *G528_GET_NOTCH_FILTER)(INT32 hDevice, UINT32 NotchFilterIndex, BOOL *Enabled);
//SetNotchFilterFrequency
typedef BOOL (__stdcall *G528_SET_NOTCH_FILTER_FREQUENCY)(INT32 hDevice, UINT32 NotchFilterIndex, INT32 Frequency);
//GetNotchFilterFrequency
typedef BOOL (__stdcall *G528_GET_NOTCH_FILTER_FREQUENCY)(INT32 hDevice, UINT32 NotchFilterIndex, INT32 *Frequency);
//SetNotchFilterBandwidth
typedef BOOL (__stdcall *G528_SET_NOTCH_FILTER_BANDWIDTH)(INT32 hDevice, UINT32 NotchFilterIndex, UINT32 Bandwidth);
//GetNotchFilterBandwidth
typedef BOOL (__stdcall *G528_GET_NOTCH_FILTER_BANDWIDTH)(INT32 hDevice, UINT32 NotchFilterIndex, UINT32 *Bandwidth);
//SetNotchFilterLength
typedef BOOL (__stdcall *G528_SET_NOTCH_FILTER_LENGTH)(INT32 hDevice, UINT32 NotchFilterIndex, UINT32 Length);
//GetNotchFilterLength
typedef BOOL (__stdcall *G528_GET_NOTCH_FILTER_LENGTH)(INT32 hDevice, UINT32 NotchFilterIndex, UINT32 *Length);
//SetDemodulatorMode
typedef BOOL (__stdcall *G528_SET_DEMODULATOR_MODE)(INT32 hDevice, UINT32 Mode);
//GetDemodulatorMode
typedef BOOL (__stdcall *G528_GET_DEMODULATOR_MODE)(INT32 hDevice, UINT32 *Mode);
//SetDemodulatorFrequency
typedef BOOL (__stdcall *G528_SET_DEMODULATOR_FREQUENCY)(INT32 hDevice, INT32 Frequency);
//GetDemodulatorFrequency
typedef BOOL (__stdcall *G528_GET_DEMODULATOR_FREQUENCY)(INT32 hDevice, INT32 *Frequency);
//SetDemodulatorFilterBandwidth
typedef BOOL (__stdcall *G528_SET_DEMODULATOR_FILTER_BANDWIDTH)(INT32 hDevice, UINT32 Bandwidth);
//GetDemodulatorFilterBandwidth
typedef BOOL (__stdcall *G528_GET_DEMODULATOR_FILTER_BANDWIDTH)(INT32 hDevice, UINT32 *Bandwidth);
//SetDemodulatorFilterShift
typedef BOOL (__stdcall *G528_SET_DEMODULATOR_FILTER_SHIFT)(INT32 hDevice, INT32 Shift);
//GetDemodulatorFilterShift
typedef BOOL (__stdcall *G528_GET_DEMODULATOR_FILTER_SHIFT)(INT32 hDevice, INT32 *Shift);
//SetDemodulatorFilterLength
typedef BOOL (__stdcall *G528_SET_DEMODULATOR_FILTER_LENGTH)(INT32 hDevice, UINT32 Length);
//GetDemodulatorFilterLength
typedef BOOL (__stdcall *G528_GET_DEMODULATOR_FILTER_LENGTH)(INT32 hDevice, UINT32 *Length);
//SetDemodulatorParam
typedef BOOL (__stdcall *G528_SET_DEMODULATOR_PARAM)(INT32 hDevice, UINT32 Code, CONST VOID *Buffer, UINT32 BufferSize);
//GetDemodulatorParam
typedef BOOL (__stdcall *G528_GET_DEMODULATOR_PARAM)(INT32 hDevice, UINT32 Code, VOID *Buffer, UINT32 BufferSize);
//GetDemodulatorState
typedef BOOL (__stdcall *G528_GET_DEMODULATOR_STATE)(INT32 hDevice, UINT32 Code, VOID *Buffer, UINT32 BufferSize);
//StartAudio
typedef BOOL (__stdcall *G528_START_AUDIO)(INT32 hDevice, UINT32 SamplesPerBuffer);
//StopAudio
typedef BOOL (__stdcall *G528_STOP_AUDIO)(INT32 hDevice);
//SetAudioFilter
typedef BOOL (__stdcall *G528_SET_AUDIO_FILTER)(INT32 hDevice, BOOL Enabled);
//GetAudioFilter
typedef BOOL (__stdcall *G528_GET_AUDIO_FILTER)(INT32 hDevice, BOOL *Enabled);
//SetAudioFilterParams
typedef BOOL (__stdcall *G528_SET_AUDIO_FILTER_PARAMS)(INT32 hDevice, UINT32 CutOffLow, UINT32 CutOffHigh, double Deemphasis);
//GetAudioFilterParams
typedef BOOL (__stdcall *G528_GET_AUDIO_FILTER_PARAMS)(INT32 hDevice, UINT32 *CutOffLow, UINT32 *CutOffHigh, double *Deemphasis);
//SetAudioFilterLength
typedef BOOL (__stdcall *G528_SET_AUDIO_FILTER_LENGTH)(INT32 hDevice, UINT32 Length);
//GetAudioFilterLength
typedef BOOL (__stdcall *G528_GET_AUDIO_FILTER_LENGTH)(INT32 hDevice, UINT32 *Length);
//SetAudioGain
typedef BOOL (__stdcall *G528_SET_AUDIO_GAIN)(INT32 hDevice, double Gain);
//GetAudioGain
typedef BOOL (__stdcall *G528_GET_AUDIO_GAIN)(INT32 hDevice, double *Gain);
//SetVolume
typedef BOOL (__stdcall *G528_SET_VOLUME)(INT32 hDevice, BYTE Volume);
//GetVolume
typedef BOOL (__stdcall *G528_GET_VOLUME)(INT32 hDevice, BYTE *Volume);
//SetMute
typedef BOOL (__stdcall *G528_SET_MUTE)(INT32 hDevice, BOOL Mute);
//GetMute
typedef BOOL (__stdcall *G528_GET_MUTE)(INT32 hDevice, BOOL *Mute);
//SetDRMKey
typedef BOOL (__stdcall *G528_SET_DRM_KEY)(INT32 hDevice, CONST CHAR *DRMKeyFileDirectory);
//IsDRMUnlocked
typedef BOOL (__stdcall *G528_IS_DRM_UNLOCKED)(INT32 hDevice);
//GetSpectrumCompensation
typedef BOOL (__stdcall *G528_GET_SPECTRUM_COMPENSATION)(INT32 hDevice,UINT32 CenterFrequency,UINT32 Width,FLOAT *Buffer,UINT32 Count);
//SetFrequency
typedef BOOL (__stdcall *G528_SET_FREQUENCY)(INT32 hDevice, UINT32 Frequency);
//GetFrequency
typedef BOOL (__stdcall *G528_GET_FREQUENCY)(INT32 hDevice, UINT32 *Frequency);
//GetDeviceState
typedef BOOL (__stdcall *G528_GET_DEVICE_STATE)(INT32 hDevice, UINT32 *State);
//SetDAC
typedef BOOL (__stdcall *G528_SET_DAC)(INT32 hDevice, UINT32 DAC);
//GetDAC
typedef BOOL (__stdcall *G528_GET_DAC)(INT32 hDevice, UINT32 *DAC);
//SetCallbacks
typedef BOOL (__stdcall *G528_SET_CALLBACKS)(INT32 hDevice, CONST G528_CALLBACKS *Callbacks, DWORD_PTR UserData);
//InitADC
typedef BOOL (__stdcall *G528_INIT_ADC)(INT32 hDevice);
//DisableADCOscillator
typedef BOOL (__stdcall *G528_DISABLE_ADC_OSCILLATOR)(INT32 hDevice);
//DisableADCFrequencyReference
typedef BOOL (__stdcall *G528_DISABLE_ADC_FREQUENCY_REFERENCE)(INT32 hDevice);
//IsADCClockPresent
typedef BOOL (__stdcall *G528_IS_ADC_CLOCK_PRESENT)(INT32 hDevice);
//IsADCSamplingClockLocked
typedef BOOL (__stdcall *G528_IS_ADC_SAMPLING_CLOCK_LOCKED)(INT32 hDevice);
//OpenCOMPort
typedef BOOL (__stdcall *G528_OPEN_COM_PORT)(INT32 hDevice, UINT32 Baudrate);
//CloseCOMPort
typedef BOOL (__stdcall *G528_CLOSE_COM_PORT)(INT32 hDevice);
//IsCOMPortOpened
typedef BOOL (__stdcall *G528_IS_COM_PORT_OPENED)(INT32 hDevice);
//ReadFromCOMPort
typedef BOOL (__stdcall *G528_READ_FROM_COM_PORT)(INT32 hDevice, VOID *Buffer, UINT32 BufferSize, UINT32 *ReadSize);
//WriteToCOMPort
typedef BOOL (__stdcall *G528_WRITE_TO_COM_PORT)(INT32 hDevice, VOID *Buffer, UINT32 BufferSize);
//SetCOMPortTimeout
typedef BOOL (__stdcall *G528_SET_COM_PORT_TIMEOUT)(INT32 hDevice, UINT32 Timeout);

typedef VOID (__stdcall *COH_G528_DDC1_STREAM_CALLBACK)(UINT32 DeviceCount, CONST VOID **Buffer, UINT32 NumberOfSamples, UINT32 BitsPerSample, DWORD_PTR UserData);
typedef VOID (__stdcall *COH_G528_DDC2_STREAM_CALLBACK)(UINT32 DeviceIndex, CONST FLOAT *Buffer, UINT32 NumberOfSamples, DWORD_PTR UserData);
typedef VOID (__stdcall *COH_G528_DDC2_PREPROCESSED_STREAM_CALLBACK)(UINT32 DeviceIndex, CONST FLOAT *Buffer, UINT32 NumberOfSamples, FLOAT SlevelPeak, FLOAT SlevelRMS, DWORD_PTR UserData);
typedef VOID (__stdcall *COH_G528_AUDIO_STREAM_CALLBACK)(UINT32 DeviceIndex, UINT32 Type, CONST FLOAT *Buffer, UINT32 NumberOfSamples, DWORD_PTR UserData);

#pragma pack(push,1)

typedef struct
{
	COH_G528_DDC1_STREAM_CALLBACK                 DDC1StreamCallback;
	COH_G528_DDC2_STREAM_CALLBACK                 DDC2StreamCallback;
	COH_G528_DDC2_PREPROCESSED_STREAM_CALLBACK    DDC2PreprocessedStreamCallback;
	COH_G528_AUDIO_STREAM_CALLBACK                AudioStreamCallback;
} COH_G528_CALLBACKS;

typedef struct
{
	UINT32              DeviceCount;
	G528_DEVICE_INFO		*DeviceInfo;
} COH_G528_DEVICE_SET;

typedef struct
{
	UINT32                  DeviceSetCount;
	COH_G528_DEVICE_SET			*DeviceSet;    
} COH_G528_DEVICE_SET_LIST;

#pragma pack(pop)

//CohGetDeviceSetList
typedef COH_G528_DEVICE_SET_LIST* (__stdcall *COH_G528_GET_DEVICE_SET_LIST)(void);
//CohFreeDeviceSetList
typedef void (__stdcall *COH_G528_FREE_DEVICE_SET_LIST)(COH_G528_DEVICE_SET_LIST *DeviceSetList);
//CohOpenDeviceSet
typedef INT32 (__stdcall *COH_G528_OPEN_DEVICE_SET)(G528_DEVICE_INFO *DeviceInfos, UINT32 Count);
//CohCloseDeviceSet
typedef BOOL (__stdcall *COH_G528_CLOSE_DEVICE_SET)(INT32 hDeviceSet);
//CohIsConnected
typedef BOOL (__stdcall *COH_G528_IS_CONNECTED)(INT32 hDeviceSet);
//CohSetCallbacks
typedef BOOL (__stdcall *COH_G528_SET_CALLBACKS)(INT32 hDeviceSet, const COH_G528_CALLBACKS *Callbacks, DWORD_PTR UserData);
//CohGetDeviceCount
typedef BOOL (__stdcall *COH_G528_GET_DEVICE_COUNT)(INT32 hDeviceSet, UINT32 *Count);
//CohGetDeviceInfo
typedef BOOL (__stdcall *COH_G528_GET_DEVICE_INFO)(INT32 hDeviceSet, UINT32 DeviceIndex, G528_DEVICE_INFO *Info);
//CohGetDeviceInfos
typedef BOOL (__stdcall *COH_G528_GET_DEVICE_INFOS)(INT32 hDeviceSet, G528_DEVICE_INFO *Infos, UINT32 *InfoCount);
//CohSetPower
typedef BOOL (__stdcall *COH_G528_SET_POWER)(INT32 hDeviceSet, BOOL Power);
//CohGetPower
typedef BOOL (__stdcall *COH_G528_GET_POWER)(INT32 hDeviceSet, BOOL *Power);
//CohSetInverted
typedef BOOL (__stdcall *COH_G528_SET_INVERTED)(INT32 hDeviceSet, BOOL Inverted);
//CohGetInverted
typedef BOOL (__stdcall *COH_G528_GET_INVERTED)(INT32 hDeviceSet, BOOL *Inverted);
//CohGetDDCInfo
typedef BOOL (__stdcall *COH_G528_GET_DDC_INFO)(INT32 hDeviceSet, UINT32 DDCTypeIndex, G528_DDC_INFO *Info);
//CohGetDDC1Count
typedef BOOL (__stdcall *COH_G528_GET_DDC1_COUNT)(INT32 hDeviceSet, UINT32 *Count);
//CohSetDDC1
typedef BOOL (__stdcall *COH_G528_SET_DDC1)(INT32 hDeviceSet, UINT32 DDCTypeIndex);
//CohGetDDC1
typedef BOOL (__stdcall *COH_G528_GET_DDC1)(INT32 hDeviceSet, UINT32 *DDCTypeIndex, G528_DDC_INFO *DDCInfo);
//CohStartDDC1
typedef BOOL (__stdcall *COH_G528_START_DDC1)(INT32 hDeviceSet, UINT32 SamplesPerBuffer);
//CohStopDDC1
typedef BOOL (__stdcall *COH_G528_STOP_DDC1)(INT32 hDeviceSet);
//CohSetDDC1Frequency
typedef BOOL (__stdcall *COH_G528_SET_DDC1_FREQUENCY)(INT32 hDeviceSet, UINT32 Frequency);
//CohGetDDC1Frequency
typedef BOOL (__stdcall *COH_G528_GET_DDC1_FREQUENCY)(INT32 hDeviceSet, UINT32 *Frequency);
//CohSetDDC1PhaseShift
typedef BOOL (__stdcall *COH_G528_SET_DDC1_PHASE_SHIFT)(INT32 hDeviceSet, UINT32 DeviceIndex, double PhaseShift);
//CohGetDDC1PhaseShift
typedef BOOL (__stdcall *COH_G528_GET_DDC1_PHASE_SHIFT)(INT32 hDeviceSet, UINT32 DeviceIndex, double *PhaseShift);
//CohGetDDC2
typedef BOOL (__stdcall *COH_G528_GET_DDC2)(INT32 hDeviceSet, UINT32 *DDCTypeIndex, G528_DDC_INFO *DDCInfo);
//CohStartDDC2
typedef BOOL (__stdcall *COH_G528_START_DDC2)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 SamplesPerBuffer);
//CohStopDDC2
typedef BOOL (__stdcall *COH_G528_STOP_DDC2)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohSetDDC2Frequency
typedef BOOL (__stdcall *COH_G528_SET_DDC2_FREQUENCY)(INT32 hDeviceSet, UINT32 DeviceIndex, INT32 Frequency);
//CohGetDDC2Frequency
typedef BOOL (__stdcall *COH_G528_GET_DDC2_FREQUENCY)(INT32 hDeviceSet, UINT32 DeviceIndex, INT32 *Frequency);
//CohSetDDC2NoiseBlanker
typedef BOOL (__stdcall *COH_G528_SET_DDC2_NOISE_BLANKER)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL Enabled);
//CohGetDDC2NoiseBlanker
typedef BOOL (__stdcall *COH_G528_GET_DDC2_NOISE_BLANKER)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL *Enabled);
//CohSetDDC2NoiseBlankerThreshold
typedef BOOL (__stdcall *COH_G528_SET_DDC2_NOISE_BLANKER_THRESHOLD)(INT32 hDeviceSet, UINT32 DeviceIndex, double Threshold);
//CohGetDDC2NoiseBlankerThreshold
typedef BOOL (__stdcall *COH_G528_GET_DDC2_NOISE_BLANKER_THRESHOLD)(INT32 hDeviceSet, UINT32 DeviceIndex, double *Threshold);
//CohGetDDC2NoiseBlankerExcessValue
typedef BOOL (__stdcall *COH_G528_GET_DDC2_NOISE_BLANKER_EXCESS_VALUE)(INT32 hDeviceSet, UINT32 DeviceIndex, double *Value);
//CohGetSignalLevel
typedef BOOL (__stdcall *COH_G528_GET_SIGNAL_LEVEL)(INT32 hDeviceSet, UINT32 DeviceIndex, FLOAT *Peak, FLOAT *RMS);
//CohSetAGC
typedef BOOL (__stdcall *COH_G528_SET_AGC)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL Enabled);
//CohGetAGC
typedef BOOL (__stdcall *COH_G528_GET_AGC)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL *Enabled);
//CohSetAGCParams
typedef BOOL (__stdcall *COH_G528_SET_AGC_PARAMS)(INT32 hDeviceSet, UINT32 DeviceIndex, double AttackTime, double DecayTime, double ReferenceLevel);
//CohGetAGCParams
typedef BOOL (__stdcall *COH_G528_GET_AGC_PARAMS)(INT32 hDeviceSet, UINT32 DeviceIndex, double *AttackTime, double *DecayTime, double *ReferenceLevel);
//CohSetMaxAGCGain
typedef BOOL (__stdcall *COH_G528_SET_MAX_AGC_GAIN)(INT32 hDeviceSet, UINT32 DeviceIndex, double MaxGain);
//CohGetMaxAGCGain
typedef BOOL (__stdcall *COH_G528_GET_MAX_AGC_GAIN)(INT32 hDeviceSet, UINT32 DeviceIndex, double *MaxGain);
//CohSetGain
typedef BOOL (__stdcall *COH_G528_SET_GAIN)(INT32 hDeviceSet, UINT32 DeviceIndex, double Gain);
//CohGetGain
typedef BOOL (__stdcall *COH_G528_GET_GAIN)(INT32 hDeviceSet, UINT32 DeviceIndex, double *Gain);
//CohGetCurrentGain
typedef BOOL (__stdcall *COH_G528_GET_CURRENT_GAIN)(INT32 hDeviceSet, UINT32 DeviceIndex, double *Gain);
//CohSetNotchFilter
typedef BOOL (__stdcall *COH_G528_SET_NOTCH_FILTER)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, BOOL Enabled);
//CohGetNotchFilter
typedef BOOL (__stdcall *COH_G528_GET_NOTCH_FILTER)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, BOOL *Enabled);
//CohSetNotchFilterFrequency
typedef BOOL (__stdcall *COH_G528_SET_NOTCH_FILTER_FREQUENCY)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, INT32 Frequency);
//CohGetNotchFilterFrequency
typedef BOOL (__stdcall *COH_G528_GET_NOTCH_FILTER_FREQUENCY)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, INT32 *Frequency);
//CohSetNotchFilterBandwidth
typedef BOOL (__stdcall *COH_G528_SET_NOTCH_FILTER_BANDWIDTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 Bandwidth);
//CohGetNotchFilterBandwidth
typedef BOOL (__stdcall *COH_G528_GET_NOTCH_FILTER_BANDWIDTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 *Bandwidth);
//CohSetNotchFilterLength
typedef BOOL (__stdcall *COH_G528_SET_NOTCH_FILTER_LENGTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 Length);
//CohGetNotchFilterLength
typedef BOOL (__stdcall *COH_G528_GET_NOTCH_FILTER_LENGTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 NotchFilterIndex, UINT32 *Length);
//CohSetDemodulatorMode
typedef BOOL (__stdcall *COH_G528_SET_DEMODULATOR_MODE)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Mode);
//CohGetDemodulatorMode
typedef BOOL (__stdcall *COH_G528_GET_DEMODULATOR_MODE)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 *Mode);
//CohSetDemodulatorFrequency
typedef BOOL (__stdcall *COH_G528_SET_DEMODULATOR_FREQUENCY)(INT32 hDeviceSet, UINT32 DeviceIndex, INT32 Frequency);
//CohGetDemodulatorFrequency
typedef BOOL (__stdcall *COH_G528_GET_DEMODULATOR_FREQUENCY)(INT32 hDeviceSet, UINT32 DeviceIndex, INT32 *Frequency);
//CohSetDemodulatorFilterBandwidth
typedef BOOL (__stdcall *COH_G528_SET_DEMODULATOR_FILTER_BANDWIDTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Bandwidth);
//CohGetDemodulatorFilterBandwidth
typedef BOOL (__stdcall *COH_G528_GET_DEMODULATOR_FILTER_BANDWIDTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 *Bandwidth);
//CohSetDemodulatorFilterShift
typedef BOOL (__stdcall *COH_G528_SET_DEMODULATOR_FILTER_SHIFT)(INT32 hDeviceSet, UINT32 DeviceIndex, INT32 Shift);
//CohGetDemodulatorFilterShift
typedef BOOL (__stdcall *COH_G528_GET_DEMODULATOR_FILTER_SHIFT)(INT32 hDeviceSet, UINT32 DeviceIndex, INT32 *Shift);
//CohSetDemodulatorFilterLength
typedef BOOL (__stdcall *COH_G528_SET_DEMODULATOR_FILTER_LENGTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Length);
//CohGetDemodulatorFilterLength
typedef BOOL (__stdcall *COH_G528_GET_DEMODULATOR_FILTER_LENGTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 *Length);
//CohSetDemodulatorParam
typedef BOOL (__stdcall *COH_G528_SET_DEMODULATOR_PARAM)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Code, CONST VOID *Buffer,UINT32 BufferSize);
//CohGetDemodulatorParam
typedef BOOL (__stdcall *COH_G528_GET_DEMODULATOR_PARAM)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Code, VOID *Buffer, UINT32 BufferSize);
//CohGetDemodulatorState
typedef BOOL (__stdcall *COH_G528_GET_DEMODULATOR_STATE)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Code, VOID *Buffer, UINT32 BufferSize);
//CohStartAudio
typedef BOOL (__stdcall *COH_G528_START_AUDIO)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 SamplesPerBuffer);
//CohStopAudio
typedef BOOL (__stdcall *COH_G528_STOP_AUDIO)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohSetAudioFilter
typedef BOOL (__stdcall *COH_G528_SET_AUDIO_FILTER)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL Enabled);
//CohGetAudioFilter
typedef BOOL (__stdcall *COH_G528_GET_AUDIO_FILTER)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL *Enabled);
//CohSetAudioFilterParams
typedef BOOL (__stdcall *COH_G528_SET_AUDIO_FILTER_PARAMS)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 CutOffLow, UINT32 CutOffHigh, double Deemphasis);
//CohGetAudioFilterParams
typedef BOOL (__stdcall *COH_G528_GET_AUDIO_FILTER_PARAMS)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 *CutOffLow, UINT32 *CutOffHigh, double *Deemphasis);
//CohSetAudioFilterLength
typedef BOOL (__stdcall *COH_G528_SET_AUDIO_FILTER_LENGTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Length);
//CohGetAudioFilterLength
typedef BOOL (__stdcall *COH_G528_GET_AUDIO_FILTER_LENGTH)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 *Length);
//CohSetAudioGain
typedef BOOL (__stdcall *COH_G528_SET_AUDIO_GAIN)(INT32 hDeviceSet, UINT32 DeviceIndex, double Gain);
//CohGetAudioGain
typedef BOOL (__stdcall *COH_G528_GET_AUDIO_GAIN)(INT32 hDeviceSet, UINT32 DeviceIndex, double *Gain);
//CohSetVolume
typedef BOOL (__stdcall *COH_G528_SET_VOLUME)(INT32 hDeviceSet, UINT32 DeviceIndex, BYTE Volume);
//CohGetVolume
typedef BOOL (__stdcall *COH_G528_GET_VOLUME)(INT32 hDeviceSet, UINT32 DeviceIndex, BYTE *Volume);
//CohSetMute
typedef BOOL (__stdcall *COH_G528_SET_MUTE)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL Mute);
//CohGetMute
typedef BOOL (__stdcall *COH_G528_GET_MUTE)(INT32 hDeviceSet, UINT32 DeviceIndex, BOOL *Mute);
//CohGetSpectrumCompensation
typedef BOOL (__stdcall *COH_G528_GET_SPECTRUM_COMPENSATION)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 CenterFrequency, UINT32 Width, FLOAT *Buffer, UINT32 Count);
//CohSetDRMKey
typedef BOOL (__stdcall *COH_G528_SET_DRM_KEY)(INT32 hDeviceSet, CONST CHAR *DRMKeyFileDirectory);
//CohIsDRMUnlocked
typedef BOOL (__stdcall *COH_G528_IS_DRM_UNLOCKED)(INT32 hDeviceSet);
//CohInitADC
typedef BOOL (__stdcall *COH_G528_INIT_ADC)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohDisableADCOscillator
typedef BOOL (__stdcall *COH_G528_DISABLE_ADC_OSCILLATOR)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohDisableADCFrequencyReference
typedef BOOL (__stdcall *COH_G528_DISABLE_ADC_FREQUENCY_REFERENCE)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohIsADCClockPresent
typedef BOOL (__stdcall *COH_G528_IS_ADC_CLOCK_PRESENT)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohIsADCSamplingClockLocked
typedef BOOL (__stdcall *COH_G528_IS_ADC_SAMPLING_CLOCK_LOCKED)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohOpenCOMPort
typedef BOOL (__stdcall *COH_G528_OPEN_COM_PORT)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Baudrate);
//CohCloseCOMPort
typedef BOOL (__stdcall *COH_G528_CLOSE_COM_PORT)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohIsCOMPortOpened
typedef BOOL (__stdcall *COH_G528_IS_COM_PORT_OPENED)(INT32 hDeviceSet, UINT32 DeviceIndex);
//CohReadFromCOMPort
typedef BOOL (__stdcall *COH_G528_READ_FROM_COM_PORT)(INT32 hDeviceSet, UINT32 DeviceIndex, VOID *Buffer, UINT32 BufferSize, UINT32 *ReadSize);
//CohWriteToCOMPort
typedef BOOL (__stdcall *COH_G528_WRITE_TO_COM_PORT)(INT32 hDeviceSet, UINT32 DeviceIndex, VOID *Buffer, UINT32 BufferSize);
//CohSetCOMPortTimeout
typedef BOOL (__stdcall *COH_G528_SET_COM_PORT_TIMEOUT)(INT32 hDeviceSet, UINT32 DeviceIndex, UINT32 Timeout);

#endif
